String
Date: 2016-06-24

java.lang

## Class String

- java.lang.Object
- - java.lang.String

- All Implemented Interfaces:
    Serializable, CharSequence, Comparable

      public final class String
      extends Object
      implements Serializable, CharSequence, Comparable

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Comparator` | `CASE_INSENSITIVE_ORDER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `String()`
    `String(byte[] var0)`
    `String(byte[] var0, int var1, int var2)`
    `String(byte[] var0, int var1, int var2, String var3)`
    `String(byte[] var0, String var1)`
    `String(char[] var0)`
    `String(char[] var0, int var1, int var2)`
    `String(String var0)`
    `String(StringBuffer var0)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `char` | `charAt(int var0)`
    `int` | `compareTo(Object var0)`
    `int` | `compareTo(String var0)`
    `int` | `compareToIgnoreCase(String var0)`
    `String` | `concat(String var0)`
    `boolean` | `contentEquals(StringBuffer var0)`
    `static String` | `copyValueOf(char[] var0)`
    `static String` | `copyValueOf(char[] var0, int var1, int var2)`
    `boolean` | `endsWith(String var0)`
    `boolean` | `equalsIgnoreCase(String var0)`
    `byte[]` | `getBytes()`
    `byte[]` | `getBytes(String var0)`
    `void` | `getChars(int var0, int var1, char[] var2, int var3)`
    `int` | `indexOf(int var0)`
    `int` | `indexOf(int var0, int var1)`
    `int` | `indexOf(String var0)`
    `int` | `indexOf(String var0, int var1)`
    `String` | `intern()`
    `int` | `lastIndexOf(int var0)`
    `int` | `lastIndexOf(int var0, int var1)`
    `int` | `lastIndexOf(String var0)`
    `int` | `lastIndexOf(String var0, int var1)`
    `int` | `length()`
    `boolean` | `regionMatches(boolean var0, int var1, String var2, int var3, int var4)`
    `boolean` | `regionMatches(int var0, String var1, int var2, int var3)`
    `String` | `replace(char var0, char var1)`
    `boolean` | `startsWith(String var0)`
    `boolean` | `startsWith(String var0, int var1)`
    `CharSequence` | `subSequence(int var0, int var1)`
    `String` | `substring(int var0)`
    `String` | `substring(int var0, int var1)`
    `char[]` | `toCharArray()`
    `String` | `toLowerCase()`
    `String` | `toLowerCase(Locale var0)`
    `String` | `toUpperCase()`
    `String` | `toUpperCase(Locale var0)`
    `String` | `trim()`
    `static String` | `valueOf(boolean var0)`
    `static String` | `valueOf(char var0)`
    `static String` | `valueOf(char[] var0)`
    `static String` | `valueOf(char[] var0, int var1, int var2)`
    `static String` | `valueOf(double var0)`
    `static String` | `valueOf(float var0)`
    `static String` | `valueOf(int var0)`
    `static String` | `valueOf(long var0)`
    `static String` | `valueOf(Object var0)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.lang.CharSequence

      `toString`

- - ### Field Detail

    - #### CASE_INSENSITIVE_ORDER

          public static final Comparator CASE_INSENSITIVE_ORDER

  - ### Constructor Detail

    - #### String

          public String()

    - #### String

          public String(String var0)

    - #### String

          public String(StringBuffer var0)

    - #### String

          public String(byte[] var0)

    - #### String

          public String(byte[] var0,
                int var1,
                int var2)

    - #### String

          public String(byte[] var0,
                int var1,
                int var2,
                String var3)
                 throws UnsupportedEncodingException

      Throws:
        `UnsupportedEncodingException`

    - #### String

          public String(byte[] var0,
                String var1)
                 throws UnsupportedEncodingException

      Throws:
        `UnsupportedEncodingException`

    - #### String

          public String(char[] var0)

    - #### String

          public String(char[] var0,
                int var1,
                int var2)

  - ### Method Detail

    - #### charAt

          public char charAt(int var0)

      Specified by:
        `charAt` in interface `CharSequence`

    - #### compareTo

          public int compareTo(Object var0)

      Specified by:
        `compareTo` in interface `Comparable`

    - #### compareTo

          public int compareTo(String var0)

    - #### compareToIgnoreCase

          public int compareToIgnoreCase(String var0)

    - #### concat

          public String concat(String var0)

    - #### contentEquals

          public boolean contentEquals(StringBuffer var0)

    - #### copyValueOf

          public static String copyValueOf(char[] var0)

    - #### copyValueOf

          public static String copyValueOf(char[] var0,
                           int var1,
                           int var2)

    - #### endsWith

          public boolean endsWith(String var0)

    - #### equalsIgnoreCase

          public boolean equalsIgnoreCase(String var0)

    - #### getBytes

          public byte[] getBytes()

    - #### getBytes

          public byte[] getBytes(String var0)
                          throws UnsupportedEncodingException

      Throws:
        `UnsupportedEncodingException`

    - #### getChars

          public void getChars(int var0,
                      int var1,
                      char[] var2,
                      int var3)

    - #### indexOf

          public int indexOf(int var0)

    - #### indexOf

          public int indexOf(int var0,
                    int var1)

    - #### indexOf

          public int indexOf(String var0)

    - #### indexOf

          public int indexOf(String var0,
                    int var1)

    - #### intern

          public String intern()

    - #### lastIndexOf

          public int lastIndexOf(int var0)

    - #### lastIndexOf

          public int lastIndexOf(int var0,
                        int var1)

    - #### lastIndexOf

          public int lastIndexOf(String var0)

    - #### lastIndexOf

          public int lastIndexOf(String var0,
                        int var1)

    - #### length

          public int length()

      Specified by:
        `length` in interface `CharSequence`

    - #### regionMatches

          public boolean regionMatches(int var0,
                              String var1,
                              int var2,
                              int var3)

    - #### regionMatches

          public boolean regionMatches(boolean var0,
                              int var1,
                              String var2,
                              int var3,
                              int var4)

    - #### replace

          public String replace(char var0,
                       char var1)

    - #### startsWith

          public boolean startsWith(String var0)

    - #### startsWith

          public boolean startsWith(String var0,
                           int var1)

    - #### subSequence

          public CharSequence subSequence(int var0,
                                 int var1)

      Specified by:
        `subSequence` in interface `CharSequence`

    - #### substring

          public String substring(int var0)

    - #### substring

          public String substring(int var0,
                         int var1)

    - #### toCharArray

          public char[] toCharArray()

    - #### toLowerCase

          public String toLowerCase()

    - #### toLowerCase

          public String toLowerCase(Locale var0)

    - #### toUpperCase

          public String toUpperCase()

    - #### toUpperCase

          public String toUpperCase(Locale var0)

    - #### trim

          public String trim()

    - #### valueOf

          public static String valueOf(char var0)

    - #### valueOf

          public static String valueOf(double var0)

    - #### valueOf

          public static String valueOf(float var0)

    - #### valueOf

          public static String valueOf(int var0)

    - #### valueOf

          public static String valueOf(long var0)

    - #### valueOf

          public static String valueOf(Object var0)

    - #### valueOf

          public static String valueOf(boolean var0)

    - #### valueOf

          public static String valueOf(char[] var0)

    - #### valueOf

          public static String valueOf(char[] var0,
                       int var1,
                       int var2)